﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using System.IO;
using System.Net;
using System.Data;
using System.Data.SqlClient;

public partial class MassMailing : System.Web.UI.Page
{
    string ConnString = System.Configuration.ConfigurationManager.ConnectionStrings["intjour_conn_str"].ConnectionString;
    string mail_server = null;
    int port;
    string display_name = null;
    string email = null;
    string password = null;
    protected void Page_Load(object sender, EventArgs e)
    {
        CheckForServer();
        LoadmailInfo();
        HyperLink24.NavigateUrl = "mailList/" + Page.RouteData.Values["id"] as string;

    }  
    void CheckForServer()
    {
        string jour_id = Page.RouteData.Values["id"] as string;
        SqlConnection conn = new SqlConnection(ConnString);
        SqlCommand cmdd = new SqlCommand();
        cmdd.Connection = conn;
        cmdd.CommandText = "SELECT * FROM MAIL_SERVER";
        cmdd.CommandType = CommandType.Text;

        conn.Open();
        SqlDataReader rdr = cmdd.ExecuteReader();
        if (rdr.HasRows)
        {
            rdr.Read();
            {
                mail_server = rdr["MAIL_SERVER"].ToString();
                port =Convert.ToInt32(rdr["MAIL_PORT"]);
                display_name = rdr["DISPLAY_NAME"].ToString();
                email = rdr["MAIL_ADDRESS"].ToString();
                password = rdr["MAIL_PASSWORD"].ToString();
            }
        }
        else
        {
            conn.Close();
            Response.Redirect("~/login_details/" + jour_id + "/new");
        }
        conn.Close();
    }
    void LoadmailInfo()
    {
        SqlConnection conn = new SqlConnection(ConnString);
        SqlCommand cmdd = new SqlCommand();
        cmdd.Connection = conn;
        cmdd.CommandText = "SELECT * FROM MAIL_MESSAGE WHERE MAIL_ID=@ID";
        cmdd.Parameters.Add("@ID", SqlDbType.Int).Value = Page.RouteData.Values["mid"] as string;
        cmdd.CommandType = CommandType.Text;

        conn.Open();
        SqlDataReader rdr = cmdd.ExecuteReader();

        if (rdr.HasRows)
        {
            rdr.Read();
            {
                ViewState["subject"] = Label3.Text = rdr["MAIL_SUBJECT"].ToString();
                ViewState["body"] = Label4.Text = rdr["MAIL_BODY"].ToString();
                ViewState["lastReceiver"] = rdr["MAIL_LAST_RECEIVER"].ToString();
            }
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        sendMail();
    }
    void sendMail()
    {
        string lastID = "";
        SqlConnection conn = new SqlConnection(ConnString);
        SqlCommand cmdd = new SqlCommand();
        cmdd.Connection = conn;
        cmdd.CommandText = "SELECT TOP 400 CONTACT_ID,CONTACT_MAIL FROM MAILINT_LIST_DT WHERE CONTACT_ID>@LAST ORDER BY CONTACT_ID ASC";
        cmdd.Parameters.Add("@LAST", SqlDbType.Int).Value = ViewState["lastReceiver"].ToString();
        cmdd.CommandType = CommandType.Text;

        conn.Open();
        SqlDataReader rdr = cmdd.ExecuteReader();

        if (rdr.HasRows)
        {
            while (rdr.Read())
            {
                MailMessage ConfrmMail = new MailMessage();
                MailAddress CnfrmMailAdrs = new MailAddress(email, display_name);
                ConfrmMail.To.Add(rdr["CONTACT_MAIL"].ToString());
                ConfrmMail.From = CnfrmMailAdrs;
                ConfrmMail.IsBodyHtml = true;
                ConfrmMail.Subject = ViewState["subject"].ToString();
                string ConfirmMail = ViewState["body"].ToString();
                ConfrmMail.Body = ConfirmMail;

                SmtpClient ConfrmClnt = new SmtpClient();
                ConfrmClnt.Host = mail_server;
                ConfrmClnt.Port = port;
                ConfrmClnt.EnableSsl = true;
                ConfrmClnt.DeliveryMethod = System.Net.Mail.SmtpDeliveryMethod.Network;
                ConfrmClnt.Credentials = new System.Net.NetworkCredential(email, password);
                ConfrmClnt.Send(ConfrmMail);
                ConfrmClnt.Dispose();
                lastID = rdr["CONTACT_ID"].ToString();
            }
        }
        conn.Close();
        saveMailMessage(lastID);
    }
    void saveMailMessage(string lastID)
    {
        SqlConnection conn = new SqlConnection(ConnString);
        SqlCommand cmdd = new SqlCommand();
        cmdd.Connection = conn;
        cmdd.CommandText = "UPDATE MAIL_MESSAGE SET MAIL_LAST_RECEIVER=@LAST WHERE MAIL_ID=@ID";
        cmdd.CommandType = CommandType.Text;

        cmdd.Parameters.Add("@ID", SqlDbType.Int).Value = Page.RouteData.Values["mid"] as string;
        cmdd.Parameters.Add("@LAST", SqlDbType.Int).Value = lastID;

        conn.Open();
        cmdd.ExecuteNonQuery();
        conn.Close();
    }

}