﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.IO;

public partial class admin_AddCategory : System.Web.UI.Page
{
    string cxConnString = System.Configuration.ConfigurationManager.ConnectionStrings["intjour_conn_str"].ConnectionString;
    protected void Page_Load(object sender, EventArgs e)
    {
        if(!IsPostBack)
        LoadVolumes();
    }
    public void LoadVolumes()
    {
        SqlConnection conn = null;

        try
        {
            conn = new SqlConnection(cxConnString);
            conn.Open();
            SqlCommand apCmdd3 = new SqlCommand("select VOLUME_NAME,VOLUME_ID from VOLUMES_DT where VOLUME_JOURNAL=@journal order by VOLUME_DATE asc");
            apCmdd3.Parameters.Add("@journal", SqlDbType.VarChar, 150).Value = Session["journame"].ToString();
            apCmdd3.Connection = conn;
            SqlDataReader apRdr3 = apCmdd3.ExecuteReader();

            if (apRdr3.HasRows)
            {
                while (apRdr3.Read())
                {
                    ListItem li = new ListItem();
                    li.Text = apRdr3["VOLUME_NAME"].ToString();
                    li.Value = apRdr3["VOLUME_ID"].ToString();
                    DropDownList1.Items.Add(li);                   
                }
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            conn.Close();
        }
    }
    protected void ImageButton1_Click(object sender, EventArgs e)
    {
        try
        {
            string ext = Path.GetExtension(FileUpload1.FileName);
           
            if (ext==".pdf" || ext==".doc" || ext==".docx")
            {
                Random r = new Random();
                int randID;
                randID = r.Next(1000000, 999999999);

                string ServerPath = Server.MapPath("~/Journals/");
                string path = ServerPath + Session["journame"].ToString() + "/" + DropDownList1.SelectedValue + "/" + randID + ext;
                string url = "http://panel.intjour.com/Journals/" + Session["journame"].ToString() + "/" + DropDownList1.SelectedValue + "/" + randID + ext;


                FileUpload1.SaveAs(path);
                submit_paper(randID, ext, url);
                paper_author1(randID);

                if (author2.Text != "")
                    paper_author2(randID);
                if (author3.Text != "")
                    paper_author3(randID);
                if (author4.Text != "")
                    paper_author4(randID);

                Response.Redirect("Confirmation.aspx?content=paper_add");

            }
            else
            {
                Page.ClientScript.RegisterClientScriptBlock(typeof(Page), Guid.NewGuid().ToString(), "alert('Please choose a valid file')", true);
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
        }
    }
    void submit_paper(int P_ID, string extension, string url)
    {
        SqlConnection con = null;
        try
        {
            con = new SqlConnection(cxConnString);   
            SqlCommand cmd = new SqlCommand("PAPERS_PRO");
            cmd.Connection = con;
            cmd.CommandType = CommandType.StoredProcedure;

            cmd.Parameters.Add("@PAPER_ID", SqlDbType.Int).Value = P_ID;
            cmd.Parameters.Add("@PAPER_NAME", SqlDbType.VarChar).Value = TextBox1.Text;
            cmd.Parameters.Add("@PAPER_VOLUME_ID", SqlDbType.Int).Value = DropDownList1.SelectedValue;
            cmd.Parameters.Add("@PAPER_ABSTRACT", SqlDbType.VarChar).Value = TextBox5.Text;
            cmd.Parameters.Add("@PAPER_KEYWORDS", SqlDbType.VarChar).Value = TextBox4.Text;
            cmd.Parameters.Add("@PAPER_STATUS", SqlDbType.VarChar).Value = "Approved";
            cmd.Parameters.Add("@PAPER_EX", SqlDbType.VarChar).Value = extension;
            cmd.Parameters.Add("@PAPER_URL", SqlDbType.VarChar).Value = url;
            cmd.Parameters.Add("@PAPER_TIME", SqlDbType.DateTime).Value = DateTime.Now.ToString();
            cmd.Parameters.Add("@PAPER_JOURNAL", SqlDbType.VarChar).Value = Session["jourfullname"].ToString();

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            con.Close();
        }
    }
    void paper_author1(int id)
    {
        SqlConnection con = null;
        try
        {
            con = new SqlConnection(cxConnString);
            SqlCommand cmd = new SqlCommand("PAPER_AUTHOR_PRO");
            cmd.Connection = con;
            cmd.CommandType = CommandType.StoredProcedure;

            cmd.Parameters.Add("@PA_NAME", SqlDbType.VarChar).Value = author1.Text;
            cmd.Parameters.Add("@PA_EMAIL", SqlDbType.VarChar).Value = mail1.Text;
            cmd.Parameters.Add("@PA_PAPER_ID", SqlDbType.Int).Value = id;
            cmd.Parameters.Add("@PA_DETAILS", SqlDbType.VarChar).Value = details1.Text;

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            con.Close();
        }
    }

    void paper_author2(int id)
    {
        SqlConnection con = null;
        try
        {
            con = new SqlConnection(cxConnString);
            SqlCommand cmd = new SqlCommand("PAPER_AUTHOR_PRO");
            cmd.Connection = con;
            cmd.CommandType = CommandType.StoredProcedure;


            cmd.Parameters.Add("@PA_NAME", SqlDbType.VarChar).Value = author2.Text;
            cmd.Parameters.Add("@PA_EMAIL", SqlDbType.VarChar).Value = mail2.Text;
            cmd.Parameters.Add("@PA_PAPER_ID", SqlDbType.Int).Value = id;
            cmd.Parameters.Add("@PA_DETAILS", SqlDbType.VarChar).Value = details2.Text;

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            con.Close();
        }
    }

    void paper_author3(int id)
    {
        SqlConnection con = null;
        try
        {
            con = new SqlConnection(cxConnString);
            SqlCommand cmd = new SqlCommand("PAPER_AUTHOR_PRO");
            cmd.Connection = con;
            cmd.CommandType = CommandType.StoredProcedure;


            cmd.Parameters.Add("@PA_NAME", SqlDbType.VarChar).Value = author3.Text;
            cmd.Parameters.Add("@PA_EMAIL", SqlDbType.VarChar).Value = mail3.Text;
            cmd.Parameters.Add("@PA_PAPER_ID", SqlDbType.Int).Value = id;
            cmd.Parameters.Add("@PA_DETAILS", SqlDbType.VarChar).Value = details3.Text;

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            con.Close();
        }
    }

    void paper_author4(int id)
    {
        SqlConnection con = null;
        try
        {
            con = new SqlConnection(cxConnString);
            SqlCommand cmd = new SqlCommand("PAPER_AUTHOR_PRO");
            cmd.Connection = con;
            cmd.CommandType = CommandType.StoredProcedure;


            cmd.Parameters.Add("@PA_NAME", SqlDbType.VarChar).Value = author4.Text;
            cmd.Parameters.Add("@PA_EMAIL", SqlDbType.VarChar).Value = mail4.Text;
            cmd.Parameters.Add("@PA_PAPER_ID", SqlDbType.Int).Value = id;
            cmd.Parameters.Add("@PA_DETAILS", SqlDbType.VarChar).Value = details4.Text;

            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
        finally
        {
            con.Close();
        }
    }
}